﻿Imports Windows.Media.Capture
Imports Windows.Storage
Imports Windows.Media.MediaProperties

Imports Windows.Devices.Enumeration
Imports Windows.UI.Core
Imports Windows.UI.Popups

Public NotInheritable Class MainPage
    Inherits Page
    Private myPictureFiles As IReadOnlyList(Of IStorageFile)
    Private myMediaCapture As MediaCapture
    Private Index As Integer
    Private saveBmp As BitmapImage
    Private myCamera As DeviceInformationCollection
    Private saveImageFileName As String
    Private myFile As StorageFile
    Protected Overrides Async Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        AddHandler Window.Current.VisibilityChanged, AddressOf Current_Changed
        Await DataShow()
        MyBase.OnNavigatedTo(e)
    End Sub

    Private Async Sub Current_Changed(sender As Object, e As VisibilityChangedEventArgs)
        If e.Visible = True Then
            Await CameraRestart()
        Else
            Exit Sub
        End If
    End Sub
    '追加処理
    Private Async Function CameraRestart() As Task
        myMediaCapture = New MediaCapture
        Try
            Dim settings = New MediaCaptureInitializationSettings()
            settings.VideoDeviceId = myCamera(0).Id
            Await myMediaCapture.InitializeAsync(settings)
            CaptureElement1.Source = myMediaCapture
            Await myMediaCapture.StartPreviewAsync
        Catch
            Exit Function
        End Try
    End Function


    Private Async Function DataShow() As Task
        Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim SubFolder = Await myFolder.CreateFolderAsync("CameraSample", CreationCollisionOption.OpenIfExists)
        Dim myPictureFile = Await SubFolder.GetFilesAsync
        Try
            cameraComboBox.Items.Clear()
            myCamera = Await DeviceInformation.FindAllAsync(DeviceClass.VideoCapture)
            For i As Integer = 0 To myCamera.Count - 1
                Dim cameraInfo = myCamera(i)
                cameraComboBox.Items.Add(cameraInfo.Name)
            Next
            cameraComboBox.SelectedIndex = 0
            myMediaCapture = New MediaCapture
            Await myMediaCapture.InitializeAsync()
            CaptureElement1.Source = myMediaCapture
            Await myMediaCapture.StartPreviewAsync
        Catch
            ErrorShow()
        End Try
    End Function

    Private Async Sub ErrorShow()
        Dim message As New MessageDialog("カメラが装備されておりません。")
        Await message.ShowAsync
        shutterButton.IsEnabled = False
        Exit Sub
    End Sub
    Private Async Sub shutterButton_Click(sender As Object, e As RoutedEventArgs) Handles shutterButton.Click
        Dim myFolder As StorageFolder = Windows.Storage.KnownFolders.PicturesLibrary
        Dim mySubFolder = Await myFolder.CreateFolderAsync("CameraSample", CreationCollisionOption.OpenIfExists)
        myFile = Await mySubFolder.CreateFileAsync(DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & ".png")
        saveImageFileName = DateTime.Now.ToString("yyyy年MM月dd日HH時mm分ss秒") & ".png"
        Dim myImageEncodingProperty As New ImageEncodingProperties
        myImageEncodingProperty.Subtype = "png"
        myImageEncodingProperty.Width = 640
        myImageEncodingProperty.Height = 480

        Await myMediaCapture.CapturePhotoToStorageFileAsync(myImageEncodingProperty, myFile)

        myPictureFiles = Await mySubFolder.GetFilesAsync()
        Index = myPictureFiles.Count
        saveBmp = New BitmapImage
        saveBmp.SetSource(Await myPictureFiles(Index - 1).OpenReadAsync)
        Image1.Source = saveBmp
        Dim message As New MessageDialog("ピクチャーフォルダ内のCameraSampleフォルダ―に保存しました。")
        Await message.ShowAsync
    End Sub
End Class
